<script setup lang="ts">
import { onMounted, reactive, watch } from "vue";
import { DocumentationEnum } from "@/client/types.gen";
import WorkflowDocumentationTabs from "@/components/workflows/WorkflowDocumentationTabs.vue";
import { useWorkflowStore } from "@/stores/workflows";

const props = defineProps<{
  versionId: string;
  workflowId: string;
  workflowModeId?: string;
}>();

const workflowRepository = useWorkflowStore();

const versionState = reactive<{
  loading: boolean;
  fileLoading: boolean;
  parameterSchema: Record<string, never>;
}>({
  loading: true,
  fileLoading: true,
  parameterSchema: {},
});

watch(
  () => props.versionId,
  (newVersionId, oldVersionId) => {
    if (newVersionId !== oldVersionId) {
      // If bucket is changed, update the objects
      downloadVersionFiles();
    }
  },
);

watch(
  () => props.workflowModeId,
  (newModeId, oldModeId) => {
    if (newModeId !== oldModeId) {
      workflowRepository
        .fetchWorkflowDocumentation(
          props.workflowId,
          props.versionId,
          DocumentationEnum.PARAMETER_SCHEMA_JSON,
          newModeId,
        )
        .then((schema) => {
          versionState.parameterSchema = schema;
        });
    }
  },
);

function downloadVersionFiles() {
  versionState.fileLoading = true;
  const descriptionPromise = workflowRepository.fetchWorkflowDocumentation(
    props.workflowId,
    props.versionId,
    DocumentationEnum.USAGE_MD,
  );
  const changelogPromise = workflowRepository.fetchWorkflowDocumentation(
    props.workflowId,
    props.versionId,
    DocumentationEnum.CHANGELOG_MD,
  );
  const parameterPromise = workflowRepository
    .fetchWorkflowDocumentation(
      props.workflowId,
      props.versionId,
      DocumentationEnum.PARAMETER_SCHEMA_JSON,
      props.workflowModeId,
    )
    .then((schema) => {
      versionState.parameterSchema = schema;
    });
  const usagePromise = workflowRepository.fetchWorkflowDocumentation(
    props.workflowId,
    props.versionId,
    DocumentationEnum.INPUT_MD,
  );
  const outputPromise = workflowRepository.fetchWorkflowDocumentation(
    props.workflowId,
    props.versionId,
    DocumentationEnum.OUTPUT_MD,
  );
  const citationsPromise = workflowRepository.fetchWorkflowDocumentation(
    props.workflowId,
    props.versionId,
    DocumentationEnum.CITATIONS_MD,
  );
  Promise.all([
    descriptionPromise,
    changelogPromise,
    parameterPromise,
    usagePromise,
    outputPromise,
    citationsPromise,
    workflowRepository.fetchWorkflowDocumentation(
      props.workflowId,
      props.versionId,
      DocumentationEnum.CLOWM_INFO_JSON,
    ),
  ]).finally(() => {
    versionState.fileLoading = false;
  });
}

onMounted(() => {
  downloadVersionFiles();
});
</script>

<template>
  <workflow-documentation-tabs
    :parameter-schema="versionState.parameterSchema"
    :clowm-info="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.CLOWM_INFO_JSON
      ]
    "
    :loading="versionState.fileLoading"
    :changelog-markdown="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.CHANGELOG_MD
      ]
    "
    :description-markdown="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.USAGE_MD
      ]
    "
    :usage-markdown="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.INPUT_MD
      ]
    "
    :output-markdown="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.OUTPUT_MD
      ]
    "
    :citations-markdown="
      workflowRepository.documentationFiles[props.versionId]?.[
        DocumentationEnum.CITATIONS_MD
      ]
    "
    :parameter-extension="
      workflowRepository.versionMapping[props.versionId]?.parameter_extension
    "
  />
</template>

<style scoped></style>
